eclass/tests/toolchain-funcs.sh add test for 'tc-cpp-is-true()'
authorSergei Trofimovich <slyfox@gentoo.org>
Wed, 6 Nov 2019 22:40:18 +0000 (22:40 +0000)
committerSergei Trofimovich <slyfox@gentoo.org>
Wed, 6 Nov 2019 22:44:34 +0000 (22:44 +0000)
With patch from bug #698912 reverted we observe failures as:
 * Testing tc-cpp-is-true (gcc, defined) ...              [ ok ]
 * Testing tc-cpp-is-true (gcc, not defined) ...          [ ok ]
 * Testing tc-cpp-is-true (gcc, defined on -ggdb3) ...    [ !! ]
 * Testing tc-cpp-is-true (clang, defined) ...            [ !! ]
 * Testing tc-cpp-is-true (clang, not defined) ...        [ ok ]
 * Testing tc-cpp-is-true (clang, defined on -ggdb3) ...  [ !! ]

Closes: https://bugs.gentoo.org/698912
Signed-off-by: Sergei Trofimovich <slyfox@gentoo.org>
eclass/tests/toolchain-funcs.sh

index bcf57f78201af8f7ffd4cf0962676b1655621759..79ba6fa407b5d4fadea192538f6221edd354f634 100755 (executable)
@@ -172,4 +172,28 @@ if type -P pathcc &>/dev/null; then
        tend $?
 fi
 
+for compiler in gcc clang; do
+       if type -P ${compielr} &>/dev/null; then
+               tbegin "tc-cpp-is-true ($compiler, defined)"
+               (
+                       export CC=${compiler}
+                       tc-cpp-is-true "defined(SOME_DEFINED_SYMBOL)" -DSOME_DEFINED_SYMBOL
+               )
+               tend $?
+               tbegin "tc-cpp-is-true ($compiler, not defined)"
+               (
+                       export CC=${compiler}
+                       ! tc-cpp-is-true "defined(SOME_UNDEFINED_SYMBOL)"
+               )
+               tend $?
+
+               tbegin "tc-cpp-is-true ($compiler, defined on -ggdb3)"
+               (
+                       export CC=${compiler}
+                       tc-cpp-is-true "defined(SOME_DEFINED_SYMBOL)" -DSOME_DEFINED_SYMBOL -ggdb3
+               )
+               tend $?
+       fi
+done
+
 texit